package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.CipherParameters;
import cn.com.infosec.crypto.Mac;
import cn.com.infosec.crypto.PBEParametersGenerator;
import cn.com.infosec.crypto.digests.SHA1Digest;
import cn.com.infosec.crypto.macs.HMac;
import cn.com.infosec.crypto.params.KeyParameter;
import cn.com.infosec.crypto.params.ParametersWithIV;

public class PKCS5S2ParametersGenerator extends PBEParametersGenerator {
   private Mac hMac;

   public PKCS5S2ParametersGenerator() {
      PKCS5S2ParametersGenerator var10000 = this;
      super();
      HMac var2;
      HMac var10001 = var2 = new HMac;
      SHA1Digest var1;
      var1 = new SHA1Digest.<init>();
      var10001.<init>(var1);
      var10000.hMac = var2;
   }

   private void F(byte[] P, byte[] S, int c, byte[] iBuf, byte[] out, int outOff) {
      int var7;
      byte[] var8 = new byte[var7 = this.hMac.getMacSize()];
      KeyParameter var9;
      var9 = new KeyParameter.<init>(P);
      this.hMac.init(var9);
      if (S != null) {
         this.hMac.update(S, 0, S.length);
      }

      this.hMac.update(iBuf, 0, iBuf.length);
      this.hMac.doFinal(var8, 0);
      System.arraycopy(var8, 0, out, outOff, var7);
      if (c == 0) {
         throw new IllegalArgumentException("iteration count must be at least 1.");
      } else {
         for(int P1 = 1; P1 < c; ++P1) {
            this.hMac.init(var9);
            this.hMac.update(var8, 0, var7);
            this.hMac.doFinal(var8, 0);

            for(int S1 = 0; S1 != var7; ++S1) {
               out[iBuf] = (byte)(out[iBuf = (byte[])(outOff + S1)] ^ var8[S1]);
            }
         }

      }
   }

   private void intToOctet(byte[] buf, int i) {
      buf[0] = (byte)(i >>> 24);
      buf[1] = (byte)(i >>> 16);
      buf[2] = (byte)(i >>> 8);
      buf[3] = (byte)i;
   }

   private byte[] generateDerivedKey(int dkLen) {
      int var2;
      int var10000 = var2 = (dkLen + (dkLen = this.hMac.getMacSize()) - 1) / dkLen;
      byte[] var3 = new byte[4];
      byte[] var4 = new byte[var10000 * dkLen];

      for(int var5 = 1; var5 <= var2; ++var5) {
         this.intToOctet(var3, var5);
         byte[] var6 = super.password;
         byte[] var7 = super.salt;
         int var8 = super.iterationCount;
         int var9 = (var5 - 1) * dkLen;
         this.F(var6, var7, var8, var3, var4, var9);
      }

      return var4;
   }

   public CipherParameters generateDerivedParameters(int keySize) {
      int var2;
      byte[] keySize1 = this.generateDerivedKey(var2 = keySize / 8);
      return new KeyParameter(keySize1, 0, var2);
   }

   public CipherParameters generateDerivedParameters(int keySize, int ivSize) {
      int var3;
      byte[] ivSize1 = this.generateDerivedKey((var3 = keySize / 8) + (keySize = ivSize / 8));
      return new ParametersWithIV(new KeyParameter(ivSize1, 0, var3), ivSize1, var3, keySize);
   }

   public CipherParameters generateDerivedMacParameters(int keySize) {
      return this.generateDerivedParameters(keySize);
   }
}
